



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++中引用的本质是什么?</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++中引用的本质是什么?</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 06:53:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一般的教材上讲到引用时，都是说&ldquo;引用是对象的一个别名&rdquo;。我认为这种定义是不清晰的，不利于初学者理解引用。至少我自己曾经被这个定义困扰了一段时间。到底什么是&ldquo;别名&rdquo;？</p>
<p>实际上，引用的实质是位于xxxxxx地址上的一个xxxx类型的对象。比如教科书上常用的例子：</p>
<p>int a = 5；&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //不妨假设编译器将a分配到0x400000</p>
<p>int &amp;b = a；</p>
<p>这里面b的准确意义就是，放在0x400000地址上的一个int类型对象。这里面包括了两重含义，首先b是一个int类型对象，因此他的使用完全与 int类型对象一样。另外这个int类型对象的地址是0x400000，因此从底层来看，它具有指针的一些特性，无论你怎样传递，他都代表放在 0x400000的那个int.</p>
<p>在c++中，引用全部是const类型，定义之后不可更改。实际上&ldquo;引用&rdquo;对目标代码来说是不存在的，因为对于编译器来说，使用上例中的b就是使用 0x400000地址的那个int.引用一经定义，就不会指向别的地址，也不会指向别的类型，因此<strong>编译器不会专门开辟空间<a href="http://www.storworld.com/" rel="external nofollow noreferrer">存储</a>这个引用，而是将发送引用的地方替换为真正的地址，接收引用的地方则替换为接受指针</strong>。</p>
<p>在java中，数据对象也都是引用类型，但是这里的引用与<a href="http://c.chinaitlab.com" rel="external nofollow noreferrer">C++</a>有很大不同，他们不是const类型，可以指向一个空值，也可以随时更改其指向的内存地址。这实际上与<a href="http://c.chinaitlab.com" rel="external nofollow noreferrer">C++</a>中的指针概念完全对应。java中的引用实际上对应C++中的指针而非引用，只不过是省去了C++中指针的取地址（&amp;）与取值（*）操作。</p>
<p><strong>指针和引用的区别？</strong></p>
<pre class="prettyprint linenums">()引用在创建时必须初始化，指针可以不初始化，引用不可以为NULL指针可以。<br />
()不存在指向空值的引用，但是存在指向空值的指针。<br />
()引用初始化后不能被改变，指针可以改变所指的对象.</pre>
<p>来源：<a href="http://c.chinaitlab.com/cc/basic/200905/783891.html" rel="external nofollow noreferrer">http://c.chinaitlab.com/cc/basic/200905/783891.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kk6r58.html">Android Scroll分析&mdash;&mdash;滑动效果产生</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxj6vz9.html">JQuery经典小例子&mdash;&mdash;可编辑的表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j6ywlq.html">mongodb数据导入导出以及备份恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okgree9.html">Servlet获取当前服务器的实际路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6rej8.html">Timus 1796&period; Amusement Park 聪明题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90md7d38.html">LoadLibrary 失败 GetLastError 126</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmmkz9.html">oracle  序列介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj64zk8.html">JAVA&lowbar;SE基础&mdash;&mdash;68&period;RunTime类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9505n1v8.html">【托业】【怪兽】TEST04</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxx1e9.html">PAT 1012 数字分类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ngpoq.html">Linux监控工具Spotlight on Unix</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j17k1g9.html">【EatBook】-NO&period;2&period;EatBook&period;2&period;JavaArchitecture&period;1&period;001-《修炼Java开发技术在架构中体验设计模式和算法之美》-</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r6w128.html">TensorFlow 分布式实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjwje79.html">3&period;10 C&plus;&plus;虚基类 虚继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25rx2oq.html">android c 读写文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvedl7y9.html">android 控制POS机图文打印（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emvejj9.html">bash shell学习笔记（一）&mdash;&mdash; 常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1gk509.html">每个Web开发者都需要具备的9个软技能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8km02e59.html">javascript里用php</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pgzlvq.html">CSS基础知识---浮动，定位和盒模型</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnwr62q.html">实战案例--Grunt构建Web程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mg32jq.html">Eclipse 修改项目名称</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn5jzj8.html">2014-9-17二班----7 web project</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yk11jq.html">centos杀死进程命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdez4ov9.html">RMI</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vpx448.html">【c&plus;&plus;】中文设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdez4l79.html">swfupdate flash上传工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm5vn79.html">laravel速记（笔记）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ykoz3q.html">python - PipeMapRed&period;waitOutputThreads&lpar;&rpar;&colon; subprocess failed with code 1</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnw512q.html">nyoj-291 互素数个数  欧拉函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
